Index: orxonox/branches/buerli/gui/orxonox_gui.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui.cc	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui.cc	(revision 2707)
@@ -32,4 +32,5 @@
 #include "orxonox_gui_flags.h"
 #include "orxonox_gui_banner.h"
+#include "orxonox_gui_keys.h"
 
   Window* orxonoxGUI;
@@ -39,4 +40,5 @@
   OrxonoxGuiFlags* flags;
   OrxonoxGuiBanner* banner;
+  OrxonoxGuiKeys* keys;
 
 int main( int argc, char *argv[] )
@@ -49,5 +51,5 @@
 
 /**
- * Initializes the Gui
+   \brief Initializes the Gui
 */
 OrxonoxGui::OrxonoxGui (int argc, char *argv[])
@@ -56,5 +58,5 @@
   gtk_rc_parse( "rc" );
   
-  orxonoxGUI = new Window("Graphical Orxonox Launcher");
+  orxonoxGUI = new Window( "Grafical OrxOnoX loader, "PACKAGE_VERSION );
   orxonoxGUI->connectSignal ("destroy", orxonoxGUI->orxonox_gui_quit);
   orxonoxGUI->connectSignal ("delete_event", orxonoxGUI->orxonox_gui_quit);
@@ -75,5 +77,8 @@
       
   optionBox->fill (avBox);
-    
+
+  keys = new OrxonoxGuiKeys ();
+  optionBox->fill (keys->getWidget ());
+
   exec = new OrxonoxGuiExec (orxonoxGUI);
   optionBox->fill (exec->getWidget ());
@@ -99,16 +104,66 @@
 
 /* WIDGET */
-/**
- * Initializes a widget.
- * Nothing to do here.
- */
+
+/**
+   \brief deletes any given Widget
+   This is still pretty crappy.
+*/
+Widget::~Widget()
+{
+  //  cout << "hiding: " <<this->label <<"\n";
+  this->hide();
+  //  cout << "check if Packer: "<<this->label <<"\n";
+  if (this->is_option < 0)
+    {
+      //  cout << "get Down "<<this->label <<"\n";
+      static_cast<Packer*>(this)->down->~Widget();
+    }
+  //  cout << "next != NULL?: " <<this->label <<"\n";
+  if (this->next != NULL)
+    this->next->~Widget();
+  cout << "delete Widget: " <<this->label <<"\n";
+  //  delete widget;
+}
+
+/**
+   \brief Initializes a widget.
+   Initializes the next Pointer and the other Widget-specific Defaults.
+*/
 void Widget::init()
 {
+  next = NULL;
+  label = "";
   return;
 }
 
-/** 
- * Connect any signal to any given Sub-widget
- */
+/**
+   \brief makes the widget visible.
+*/
+void Widget::show()
+{
+  gtk_widget_show (this->widget);
+}
+
+/**
+   \brief hides the widget.
+*/
+void Widget::hide()
+{
+  gtk_widget_hide (this->widget);
+}
+
+/**
+   \brief Sets the resolution of a specific widget to the given size.
+   \param width the width of the widget to set.
+   \param height the height of the widget to set.
+*/
+void Widget::setSize(int width, int height)
+{
+  gtk_widget_set_usize (this->widget, width, height);
+}
+
+/** 
+    \brief Connect any signal to any given Sub-widget
+*/
 void Widget::connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*, void *))
 {
@@ -117,6 +172,6 @@
 
 /**
- * Connect a signal with additionally passing the whole Object
- */
+   \brief Connect a signal with additionally passing the whole Object
+*/
 void Widget::connectSignal (char* event, gint (*signal)( GtkWidget*, Widget *))
 {
@@ -125,6 +180,6 @@
 
 /**
- * Connect a signal with additionally passing a whole external Object
- */
+   \brief Connect a signal with additionally passing a whole external Object
+*/
 void Widget::connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEvent*, void *))
 {
@@ -132,29 +187,14 @@
 }
 
-
-/**
- * Function to Shows a specific widget.
- */
-void Widget::show()
-{
-  gtk_widget_show (this->widget);
-}
-
-/**
- * Moves through all the Widgets downwards from this and executes the function on them.
- \param function must be of type void and takes a Widget* as an Input.
-
- */
+/**
+   \brief Moves through all the Widgets downwards from this and executes the function on them.
+   \param function must be of type void and takes a Widget* as an Input. 
+*/
 void Widget::walkThrough (void (*function)(Widget*))
 {
   function(this);
-  switch (this->is_option)
+  if (this->is_option < 0)
     {
-    case -1:
-      static_cast<Container*>(this)->down->walkThrough (function);
-      break;
-    case -2:
-      static_cast<Box*>(this)->down->walkThrough (function);
-      break;
+      static_cast<Packer*>(this)->down->walkThrough (function);
     } 
 
@@ -163,18 +203,17 @@
 }
 
-
-/** 
- * This is for listing the option of "widget"
- \param widget specifies the widget that should be listed
+/** 
+    \brief This is for listing the option of "widget"
+    \param widget specifies the widget that should be listed
 */
 void Widget::listOptions (Widget* widget)
 {
   if (widget->is_option >= 1)
-    cout << static_cast<Option*>(widget)->option_name <<" is : " << static_cast<Option*>(widget)->value <<endl;
-}
-
-/** 
- * This is for setting the option of "widget"
- \param widget specifies the widget that should be set.
+    cout << static_cast<Option*>(widget)->label <<" is : " << static_cast<Option*>(widget)->value <<endl;
+}
+
+/** 
+    \brief This is for setting the option of "widget"
+    \param widget specifies the widget that should be set.
 */
 void Widget::setOptions (Widget* widget)
@@ -184,19 +223,60 @@
 }
 
-/* CONTAINERS*/
-
-/**
- * Initializes a Container.
- * nothing to do here
- */
+//void deleteWidget(Widget* lastWidget)
+
+
+/* PACKERS */
+
+/**
+   \brief Initializes a Packer.
+   Sets the down-pinter to NULL and other PackerSpecific-values to their defaults.
+*/
+void Packer::init (void)
+{
+  down = NULL;
+  this->setGroupName ("");
+
+
+  static_cast<Widget*>(this)->init();
+  return;
+}
+
+/**
+   \brief Sets the group name under which all the lower widgets of this will be saved.
+   \param name The name of the group.
+*/
+void Packer::setGroupName (char* name)
+{
+  groupName = name;
+}
+
+/**
+   \brief Retrieves the group name under which all the lower widgets of this will be saved.
+   \returns name The name of the group.
+*/
+char* Packer::getGroupName (void)
+{
+  return groupName;
+}
+
+/* CONTAINERS */
+
+/**
+   \brief Initializes a Container.
+   sets the Container-Specific defaults.
+*/
 void Container::init (void)
 {
+  is_option = -1;
+
+  static_cast<Packer*>(this)->init();
+
   return;
 }
 
 /**
- * Fills a Container with lowerWidget.
- * It does this by filling up the down pointer only if down points to NULL.
- \param lowerWidget the Widget that should be filled into the Container.
+   \briefFills a Container with lowerWidget.
+   It does this by filling up the down pointer only if down points to NULL.
+   \param lowerWidget the Widget that should be filled into the Container.
 */
 void Container::fill (Widget *lowerWidget)
@@ -215,7 +295,7 @@
 /* WINDOW */
 
-  /**
-   * Creating a new Window without a Name
-   */
+/**
+   \brief Creating a new Window without a Name
+*/
 Window::Window (void)
 {
@@ -224,7 +304,7 @@
 
 /**
- * Creating a Window with a name
- \param windowName the name the window should get.
- */
+   \brief Creating a Window with a name
+   \param windowName the name the window should get.
+*/
 Window::Window (char* windowName)
 {
@@ -234,20 +314,12 @@
 
 /**
- * Destoying a Window (very BAD implemented).
- * For now it just hides the window.
- */
-Window::~Window ()
-{
-  gtk_widget_hide (widget);
-}
-
-/**
- *initializes a new Window
- */
+   \brief initializes a new Window
+*/
 void Window::init()
 {
-  is_option = -1;
-  next = NULL;
-  down = NULL;
+  isOpen = true;
+
+  static_cast<Container*>(this)->init();
+
   widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_policy (GTK_WINDOW(widget), TRUE, TRUE, TRUE);
@@ -259,17 +331,19 @@
 
 /**
- * Shows all Widgets that are included within this->widget.
- */
+   \brief Shows all Widgets that are included within this->widget.
+*/
 void Window::showall ()
 {
+  isOpen = true;
   gtk_widget_show_all  (widget);
 }
 
 /**
- * Set The Window-title to title
- \param title title the Window should get.
+   \brief Set The Window-title to title
+   \param title title the Window should get.
 */
 void Window::setTitle (char* title)
 {
+  label=title;
   gtk_window_set_title (GTK_WINDOW (widget), title);
 }
@@ -295,6 +369,6 @@
 
 /** 
- * Creates a new Frame without a name
- */
+    \brief Creates a new Frame without a name
+*/
 Frame::Frame (void)
 {
@@ -303,6 +377,6 @@
 
 /**
- * Creates a new Frame with name title
- */
+   \brief Creates a new Frame with name title
+*/
 Frame::Frame (char* title)
 {
@@ -311,19 +385,11 @@
 }
 
-/**
- * Destroys given Frame (not implemented yet)
- */
-Frame::~Frame ()
-{
-}
-
-/** 
- * Initializes a new Frame with default settings
- */
+/** 
+    \brief Initializes a new Frame with default settings
+*/
 void Frame::init()
 {
-  is_option = -1;
-  next = NULL;
-  down = NULL;
+  static_cast<Container*>(this)->init();
+  
   widget = gtk_frame_new ("");
   gtk_container_set_border_width (GTK_CONTAINER (widget), 3);
@@ -331,9 +397,10 @@
 
 /**
- * Sets the Frames name to title
- \param title The title the Frame should get.
- */
+   \brief Sets the Frames name to title
+   \param title The title the Frame should get.
+*/
 void Frame::setTitle (char* title)
 {
+  label = title;
   gtk_frame_set_label (GTK_FRAME (widget), title);
 }
@@ -342,6 +409,6 @@
 
 /**
- * Creates a new EventBox with default settings.
- */
+   \brief Creates a new EventBox with default settings.
+*/
 EventBox::EventBox ()
 {
@@ -349,6 +416,6 @@
 }
 /**
- * Creates a new EventBox with name title
- \param title title the Eventbox should get (only data-structure-internal)
+   \brief Creates a new EventBox with name title
+   \param title title the Eventbox should get (only data-structure-internal)
 */
 EventBox::EventBox (char* title)
@@ -360,11 +427,12 @@
 
 /**
- * Initializes a new EventBox
- */
+   \brief Initializes a new EventBox
+*/
 void EventBox::init(void)
 {
   is_option = -1;
-  next = NULL;
-  down = NULL;
+
+  static_cast<Container*>(this)->init();
+
   widget = gtk_event_box_new ();
   gtk_container_set_border_width (GTK_CONTAINER (widget), 3);
@@ -373,25 +441,17 @@
 
 /**
- * Sets the Title of the EventBox (not implemented)
- \param title Name the EventBox should get (only datastructure-internal).
+   \brief Sets the Title of the EventBox (not implemented)
+   \param title Name the EventBox should get (only datastructure-internal).
 */
 void EventBox::setTitle (char* title)
 {
-
-}
-
-/**
- * Destructs an EventBox (not Implemented)
- */
-EventBox::~EventBox ()
-{
-}
-
+  label = title;
+}
 
 /* BOX */
 
 /**
- * Creates a new horizontal Box
- */
+   \brief Creates a new horizontal Box
+*/
 Box::Box (void)
 {
@@ -400,7 +460,7 @@
 
 /**
- * Creates a new Box of type boxtype
- \param boxtype if 'v' the Box will be vertically, if 'h' the Box will be horizontally
- */
+   \brief Creates a new Box of type boxtype
+   \param boxtype if 'v' the Box will be vertically, if 'h' the Box will be horizontally
+*/
 Box::Box (char boxtype)
 {
@@ -409,19 +469,12 @@
 
 /**
- * Destroys given Box (not implemented yet)
- */
-Box::~Box ()
-{
-}
-
-/**
- * Initializes a new Box with type boxtype
- \param boxtype see Box(char boxtype)
+   \brief Initializes a new Box with type boxtype
+   \param boxtype see Box(char boxtype)
 */
 void Box::init(char boxtype)
 {
   is_option = -2;
-  next = NULL;
-  down = NULL;
+
+  static_cast<Packer*>(this)->init();
   if (boxtype == 'v')
     {
@@ -435,13 +488,10 @@
 
 /** 
- * Fills a box with a given Widget.
- * It does this by apending the first one to its down-pointer and all its following ones to the preceding next-pointer. The last one will receive a NULL pointer as Next
- \param lowerWidget the next Widget that should be appendet to this Box
- */
+    \brief Fills a box with a given Widget.
+    It does this by apending the first one to its down-pointer and all its following ones to the preceding next-pointer. The last one will receive a NULL pointer as Next
+    \param lowerWidget the next Widget that should be appendet to this Box
+*/
 void Box::fill (Widget *lowerWidget)
 {
-  /**
-   * Fill a Box with its lowerwidgets
-   */
   gtk_box_pack_start (GTK_BOX (this->widget), lowerWidget->widget, TRUE, TRUE, 0);
   if (this->down == NULL)
@@ -462,6 +512,6 @@
 
 /**
- * Creates a new Image
- \param imagename the location of the Image on the Hard Disc
+   \brief Creates a new Image
+   \param imagename the location of the Image on the Hard Disc
 */
 Image::Image (char* imagename)
@@ -469,13 +519,15 @@
   this->init();
   widget = gtk_image_new_from_file (imagename);
-}
-
-/** 
- * Initializes a new Image
- */
+  label = imagename;
+}
+
+/** 
+    \brief Initializes a new Image
+*/
 void Image::init()
 {
   is_option = 0;
-  next = NULL;
+
+  static_cast<Widget*>(this)->init();
 }
 
@@ -484,16 +536,24 @@
 
 /**
- * Initializes a new Option: nothing to do here
- */
+   \brief Initializes a new Option.
+   sets all Option-Specific-Values to their defaults.
+*/
 void Option::init()
 {
+  value = 0;
+  flag_name = "";
+  flag_name_short = "";
+  default_value = 0;
+
+  static_cast<Widget*>(this)->init();
+
   return;
 }
 
 /**
- * This sets The FlagName of an Option and defines its default Values
- !! Options will be saved if flagname is different from "" !!
-\param flagname the Name that will be displayed in the output
-\param defaultvalue the default Value for this Option (see definition of defaultvalue
+   \brief This sets The FlagName of an Option and defines its default Values
+   !! Options will be saved if flagname is different from "" !!
+   \param flagname the Name that will be displayed in the output
+   \param defaultvalue the default Value for this Option (see definition of defaultvalue
 */
 void Option::setFlagName (char* flagname, int defaultvalue)
@@ -501,12 +561,12 @@
   flag_name = flagname;
   default_value = defaultvalue;
-  cout << "Set Flagname of " << option_name << " to " << flagname << endl;
-}
-
-/** 
- * see Option::setFlagName (char* flagname, int defaultvalue)
- \param flagname the Name that will be displayed in the output
- \param defaultvalue the default Value for this Option (see definition of defaultvalue
- \param flagnameshort a short flagname to be displayed in the output
+  cout << "Set Flagname of " << label << " to " << flagname << endl;
+}
+
+/** 
+    \brief see Option::setFlagName (char* flagname, int defaultvalue)
+    \param flagname the Name that will be displayed in the output
+    \param defaultvalue the default Value for this Option (see definition of defaultvalue
+    \param flagnameshort a short flagname to be displayed in the output
 */
 void Option::setFlagName (char* flagname, char* flagnameshort,  int defaultvalue)
@@ -515,5 +575,5 @@
   flag_name_short = flagnameshort;
   default_value = defaultvalue;
-  cout << "Set Flagname of " << option_name << " to " << flagname << endl;
+  cout << "Set Flagname of " << label << " to " << flagname << endl;
 }
 
@@ -522,6 +582,6 @@
 
 /**
- * Creates a new Button with a buttonname
- \param buttonname sets the Name of the Button
+   \brief Creates a new Button with a buttonname
+   \param buttonname sets the Name of the Button
 */
 Button::Button(char* buttonname)
@@ -532,32 +592,29 @@
 
 /**
- * Initializes a new Button
- */
+   \brief Initializes a new Button
+*/
 void Button::init(void)
 {
   is_option = 0;
-  value = 0;
-  next = NULL;
-  option_name ="";
-  flag_name = "";
-  flag_name_short = "";
-  default_value = 0;
+
+  static_cast<Option*>(this)->init();
+
   widget = gtk_button_new_with_label ("");
 }
 
 /**
- * Sets a new name to the Button
-\param title The name the Button should get
+   \brief Sets a new name to the Button
+   \param title The name the Button should get
 */
 void Button::setTitle (char *title)
 {
-  option_name = title;
+  label = title;
   gtk_button_set_label (GTK_BUTTON(widget), title);
 }
 
 /**
- * redraws the Button
- * not implemented yet
- */
+   \brief redraws the Button
+   not implemented yet
+*/
 void Button::redraw ()
 {
@@ -567,7 +624,7 @@
 
 /**
- * Creates a new CheckButton with an ame 
- \param buttonname The name the CheckButton should display.
- */
+   \brief Creates a new CheckButton with an ame 
+   \param buttonname The name the CheckButton should display.
+*/
 CheckButton::CheckButton (char* buttonname)
 {
@@ -578,33 +635,23 @@
 }
 
-/** 
- * Destructs a CheckButton (not Implemented yet).
- */
-CheckButton::~CheckButton()
-{
-}
-
-/**
- * Initiali a new CheckButton with default settings
- */
+/**
+   \brief Initialize a new CheckButton with default settings
+*/
 void CheckButton::init(void)
 {
   is_option = 1;
-  value = 0;
-  next = NULL;
-  option_name = "";
-  flag_name = "";
-  flag_name_short = "";
-  default_value = 0;
+
+  static_cast<Option*>(this)->init();
+
   widget = gtk_check_button_new_with_label ("");
 }
 
 /**
- * Sets a new Title to a CheckButton
- \param title The new Name the CheckButton should display.
+   \brief Sets a new Title to a CheckButton
+   \param title The new Name the CheckButton should display.
 */
 void CheckButton::setTitle(char* title)
 {
-  option_name = title;
+  label = title;
   gtk_button_set_label(GTK_BUTTON(widget), title);
 }
@@ -612,19 +659,19 @@
 
 /** 
- * Signal OptionChange writes the Value from the CheckButton to its Object-Database.
- \param widget The widget(CheckButton) that has a changed Value
- \param checkbutton the CheckButton-Object that should receive the change.
- */
+    \brief Signal OptionChange writes the Value from the CheckButton to its Object-Database.
+    \param widget The widget(CheckButton) that has a changed Value
+    \param checkbutton the CheckButton-Object that should receive the change.
+*/
 gint CheckButton::OptionChange (GtkWidget *widget, Widget* checkbutton)
 {
   static_cast<CheckButton*>(checkbutton)->value = (int)gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON ((CheckButton*)checkbutton->widget));
   flags->setTextFromFlags(orxonoxGUI);
-  cout << static_cast<CheckButton*>(checkbutton)->option_name << " set to: " << static_cast<CheckButton*>(checkbutton)->value << endl;
-}
-
-/**
- * Redraws the CheckButton (if option has changed).
- * Example: if new settings are loaded the Button must be redrawn for the GUI to display that Change
- */
+  cout << static_cast<CheckButton*>(checkbutton)->label << " set to: " << static_cast<CheckButton*>(checkbutton)->value << endl;
+}
+
+/**
+   \brief Redraws the CheckButton (if option has changed).
+   Example: if new settings are loaded the Button must be redrawn for the GUI to display that Change
+*/
 void CheckButton::redraw ()
 {
@@ -635,8 +682,8 @@
 
 /**
- * Creates a new Slider
- \param slidername The data-structure-name of the slider.
- \param start The minimal Value of the slider.
- \param end The maximal Value of the slider.
+   \brief Creates a new Slider
+   \param slidername The data-structure-name of the slider.
+   \param start The minimal Value of the slider.
+   \param end The maximal Value of the slider.
 */
 Slider::Slider (char* slidername, int start, int end)
@@ -649,39 +696,29 @@
 
 /**
- * Destructs a Slider (not implemented yet)
- */
-Slider::~Slider()
-{
-}
-
-/**
- * Initializes a Slider with start and end Values
- * params: see Slider::Slider (char* slidername, int start, int end)
- */
+   \brief Initializes a Slider with start and end Values
+   params: see Slider::Slider (char* slidername, int start, int end)
+*/
 void Slider::init(int start, int end)
 {
   is_option = 2;
-  value = 0;
-  next = NULL;
-  option_name = "";
-  flag_name = "";
-  flag_name_short = "";
-  default_value = 0;
+
+  static_cast<Option*>(this)->init();
+
   widget = gtk_hscale_new_with_range (start, end, 5);
 }
 
 /**
- * Sets a new Title to the Slider
- \param title The new Name of the slider
+   \brief Sets a new Title to the Slider
+   \param title The new Name of the slider
 */
 void Slider::setTitle(char* title)
 {
-  option_name = title;
-}
-
-/**
- * Setting a new value to the Slider.
- * Maybe you also require a Slider::redraw() for this to display
- */
+  label = title;
+}
+
+/**
+   \brief Setting a new value to the Slider.
+   Maybe you also require a Slider::redraw() for this to display
+*/
 void Slider::setValue(int value)
 {
@@ -690,19 +727,19 @@
 
 /** 
- * Signal OptionChange writes the Value from the Slider to its Object-Database.
- \param widget The widget(Slider) that has a changed Value
- \param slider the Slider-Object that should receive the change.
- */
+    \brief Signal OptionChange writes the Value from the Slider to its Object-Database.
+    \param widget The widget(Slider) that has a changed Value
+    \param slider the Slider-Object that should receive the change.
+*/
 gint Slider::OptionChange (GtkWidget *widget, Widget* slider)
 {
   static_cast<Slider*>(slider)->value = (int)gtk_range_get_value (GTK_RANGE ((Slider*)slider->widget));
   flags->setTextFromFlags(orxonoxGUI);
-  cout << static_cast<Slider*>(slider)->option_name << " set to: "<< static_cast<Slider*>(slider)->value << endl;
-}
-
-/**
- * Redraws the widget
- * Example: see void CheckButton::redraw ()
- */
+  cout << static_cast<Slider*>(slider)->label << " set to: "<< static_cast<Slider*>(slider)->value << endl;
+}
+
+/**
+   \brief Redraws the widget
+   Example: see void CheckButton::redraw ()
+*/
 void Slider::redraw ()
 {
@@ -713,9 +750,9 @@
 
 /** 
- * Creates a Menu-Item-list out of multiple input.
- * !! Consider, that the last input argument has to be "lastItem" for this to work!!
- \param menuname The Database-Name of this Menu
- \param ... items to be added to this Menu. !! Consider, that the last input argument has to be "lastItem" for this to work!!
- */
+    \brief Creates a Menu-Item-list out of multiple input.
+    !! Consider, that the last input argument has to be "lastItem" for this to work!!
+    \param menuname The Database-Name of this Menu
+    \param ... items to be added to this Menu. !! Consider, that the last input argument has to be "lastItem" for this to work!!
+*/
 Menu::Menu (char* menuname, ...)
 {
@@ -737,14 +774,12 @@
 
 /**
- * Initializes a new Menu with no items
- */
+   \brief Initializes a new Menu with no items
+*/
 void Menu::init(void)
 {
   is_option = 2;
-  value = 0;
-  next = NULL;
-  flag_name = "";
-  flag_name_short = "";
-  default_value = 0;
+
+  static_cast<Option*>(this)->init();
+
   widget = gtk_option_menu_new ();
   menu = gtk_menu_new ();
@@ -758,10 +793,10 @@
 void Menu::setTitle(char* title)
 {
-  option_name = title;
-}
-
-/**
- * appends a new Item to the Menu-List.
- \param itemName the itemName to be appendet.
+  label = title;
+}
+
+/**
+   \brief appends a new Item to the Menu-List.
+   \param itemName the itemName to be appendet.
 */
 void Menu::addItem (char* itemName)
@@ -772,17 +807,18 @@
 
 /** 
- * Signal OptionChange writes the Value from the Menu to its Object-Database.
- \param widget The widget(Menu) that has a changed Value
- \param menu the Menu-Object that should receive the change.
- */gint Menu::OptionChange (GtkWidget *widget, Widget* menu)
+    \brief Signal OptionChange writes the Value from the Menu to its Object-Database.
+    \param widget The widget(Menu) that has a changed Value
+    \param menu the Menu-Object that should receive the change.
+*/
+gint Menu::OptionChange (GtkWidget *widget, Widget* menu)
 {
   static_cast<Menu*>(menu)->value = (int)gtk_option_menu_get_history (GTK_OPTION_MENU (menu->widget));
   flags->setTextFromFlags(orxonoxGUI);
-  cout << static_cast<Menu*>(menu)->option_name << " changed to : " << static_cast<Menu*>(menu)->value << endl;
-}
-
-/**
- * Redraws the widget
- * Example: see void CheckButton::redraw ()
+  cout << static_cast<Menu*>(menu)->label << " changed to : " << static_cast<Menu*>(menu)->value << endl;
+}
+
+/**
+   \brief Redraws the widget
+   Example: see void CheckButton::redraw ()
  */
 void Menu::redraw ()
@@ -792,7 +828,7 @@
 
 /**
- * Creates a new default Label with no Text.
- * You migth consider adding Label::setTitle with this.
- */
+   \brief Creates a new default Label with no Text.
+   You migth consider adding Label::setTitle with this.
+*/
 Label:: Label ()
 {
@@ -801,45 +837,39 @@
 
 /**
- * Creates a new Label with a Text.
- \param text The text to be displayed.
+   \brief Creates a new Label with a Text.
+   \param text The text to be displayed.
 */
 Label:: Label (char* text)
 {
+  this->init();
+  this->setText(text);
+}
+
+/**
+   \brief initializes a new Label
+*/
+void Label::init(void)
+{
   is_option = 0;
-  next = NULL;
-  widget = gtk_label_new (text);
+
+  static_cast<Widget*>(this)->init();
+
+  widget = gtk_label_new ("");
   gtk_label_set_line_wrap (GTK_LABEL(widget), TRUE);
 }
 
-/** 
- * Destructs a Label
- */
-Label::~Label ()
-{}
-
-/**
- * initializes a new Label
- */
-void Label::init(void)
-{
-  is_option = 0;
-  next = NULL;
-  widget = gtk_label_new ("");
-  gtk_widget_set_usize (widget, 260, 60);
-  gtk_label_set_line_wrap (GTK_LABEL(widget), TRUE);
-}
-
-/**
- * Sets a new Text to a Label.
- \param text The text to be inserted into the Label.
- */
+/**
+   \brief Sets a new Text to a Label.
+   \param text The text to be inserted into the Label.
+*/
 void Label::setText (char * text)
 {
+  label = text;
   gtk_label_set_text (GTK_LABEL (this->widget), text);
 }
 
 /**
- * get the Text of a Label
- \return The Text the Label holds.
+   \brief get the Text of a Label
+   \return The Text the Label holds.
 */
 char* Label::getText ()
Index: orxonox/branches/buerli/gui/orxonox_gui.h
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui.h	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui.h	(revision 2707)
@@ -7,6 +7,9 @@
 #define _ORXONOX_GUI_H
 
+#if HAVE_CONFIG_H 
+#include <config.h> 
+#endif
+
 #include <stdlib.h>
-#include <string.h>
 #include <gtk/gtkmain.h>
 #include <gtk/gtkwindow.h>
@@ -34,18 +37,25 @@
 
 //! This is the topmost object that can be displayed all others are derived from it.
-
 class Widget
 {
  private:
  public:
+  ~Widget ();
+
   Widget* next; //!< next always points to the next Widget in the list. Every Widget has a next one, or has NULL as next
   GtkWidget* widget; //!< widget is the gtk_widget that the specific Object Contains.
-  virtual void init(void);
+  void init(void);
   int is_option; //!< with this Paramenter one can set the IsOption type: -2:Container, -1: Box, 0: not an Option, 1: Bool-option, 2: int-option
-  enum option { containerType = -2, boxType = -1, nothingType = 0, boolType = 1, intType = 2}; //!< defines is_option states
+  /**
+     \briefdefines is_option states
+  */
+  enum option { containerType = -2, boxType = -1, nothingType = 0, boolType = 1, intType = 2}; 
+  char* label; //!< The name of the Widget. Some do display it, Options need it to save;
   void connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*, void *));
   void connectSignal (char* event, gint (*signal)(GtkWidget*, Widget *));
   void connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEvent*, void *));
   void show ();
+  void hide ();
+  void setSize(int width, int height);
 
   void walkThrough (void (*function)(Widget*));
@@ -55,4 +65,15 @@
 };
 
+//! This is a Packer Object, which has the ability to Pack other Widgets into itself.
+class Packer : public Widget
+{
+ public:
+  Widget* down; //!< this points to the Widget below this.
+  char* groupName; //!< For each Packer you can specify a Groupname under which the lowerWidgets will be saved.
+
+  void init(void);
+  void setGroupName (char* name);
+  char* getGroupName (void);
+};
 
 //! This is a Container Class, it can contain one sub-Widget: down.
@@ -62,14 +83,12 @@
  * The derived classes of Container can be displayed
 */
-class Container : public Widget
+class Container : public Packer
 {
  private:
   int borderwidth;
   int policy;
-  char* label;
-  
- public:
-  void init(void);
-  Widget* down; //!< this points to the Widget below this.
+  
+ public:
+  void init(void);
   //  void setBorderWidth (int borderwidth);
   //  virtual void setTitle (char* title) = 0;
@@ -84,8 +103,9 @@
 class Window : public Container
 {
+ private:
+  bool isOpen;
  public:
   Window (char* windowName);
   Window (void);
-  ~Window ();
   void init ();
   
@@ -105,5 +125,4 @@
   Frame (char* frameName);
   Frame (void);
-  ~Frame ();
   void init(void);
   
@@ -120,5 +139,4 @@
   EventBox (char* eventBoxName);
   EventBox (void);
-  ~EventBox ();
   void init(void);
   
@@ -132,13 +150,11 @@
  * A Box is always filled left->right (horizontally) or up->down (vertically)
  */
-class Box : public Widget
+class Box : public Packer
 {
  public:
   Box (void);
   Box (char boxtype);
-  ~Box (void);
   void init(char boxtype);
 
-  Widget* down; //!< the Lower Widget of a Box.
   void fill (Widget* lowerWidget);
 
@@ -154,5 +170,4 @@
  public:
   Image (char* imgaename);
-  ~Image ();
   void init(void);
 };
@@ -169,5 +184,4 @@
 
   int value; //!< every option has a value either true or false (0,1) or something else like 25 for 25% of the volume
-  char* option_name; //!< options have a name, that can be displayed around them
   char* flag_name; //!< options have a flag name that will be appendet if you start the Program from the GUI.
   char* flag_name_short; //!< like flag_name but shorter
@@ -187,5 +201,4 @@
  public:
   Button (char* buttonname);
-  ~Button (void);
   void init(void);
 
@@ -202,5 +215,4 @@
  public:
   CheckButton (char* buttonname);
-  ~CheckButton (void);
   static gint OptionChange (GtkWidget* widget, Widget* checkbutton);
   
@@ -219,5 +231,4 @@
  public:
   Slider (char* slidername,int start, int end);
-  ~Slider ();
   void init(int start, int end);
 
@@ -239,5 +250,4 @@
  public:
   Menu (char* menuname, ...);
-  ~Menu ();
   void init(void);
 
@@ -255,5 +265,4 @@
   Label ();
   Label (char* text);
-  ~Label ();
   void init(void);
   
Index: orxonox/branches/buerli/gui/orxonox_gui_audio.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_audio.cc	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui_audio.cc	(revision 2707)
@@ -33,4 +33,5 @@
   audioFrame = new Frame ("Audio-Options:");
   audioBox = new Box ('v');
+  audioFrame->setGroupName ("audio");
   
   enableSound = new CheckButton ("Disable Sound");
Index: orxonox/branches/buerli/gui/orxonox_gui_banner.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_banner.cc	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui_banner.cc	(revision 2707)
@@ -63,5 +63,5 @@
 	  logoEventBox = new EventBox();
 	  logoBox = new Box('v');
-	  logoLabel = new Label("OrxOnoX");
+	  logoLabel = new Label("OrxOnoX, " PACKAGE_VERSION);
 	  logoImage = new Image("banner.xpm");
 	  logoEventBox->fill(logoImage);
@@ -88,5 +88,5 @@
 {
   logoWindowIsOpen = 0;
-  logoWindow->~Window();
+  logoWindow->hide();
 }
 
